//
// Copyright (C) 1999-2004 Toshikaz Hirabayashi
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// TOSHIKAZ HIRABAYASHI BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//
// Except as contained in this notice, the name of Toshikaz Hirabayashi shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from
// Toshikaz Hirabayashi.

#include <WScom.h>
#include <WSRdef.h>
#include <WSClocaleSet.h>

//WSClist list types...
char* __WSRtype[]={
"g:WSSTR Normal",
"h:WSSTR Tree",
"i:WSSTR Detail",
NULL
};

//WSClist list type values..
char* __WSRtypeD[]={
"0",
"1",
"2",
NULL
};


//blink types.
char* __WSRblinkType[]={
"j:WSSTR Foreground",
"k:WSSTR Background",
"l:WSSTR Fore/Back",
NULL
};

//blink type values.
char* __WSRblinkTypeD[]={
"0",
"1",
"2",
NULL
};

//shadow types
char* __WSRshadowType[]={
"m:WSSTR In",
"n:WSSTR Out",
"o:WSSTR Etched in",
"p:WSSTR Etched out",
"q:WSSTR Border",
"r:WSSTR None",
NULL
};

//shadow type values
char* __WSRshadowTypeD[]={
"1",
"0",
"3",
"2",
"4",
"-1",
NULL
};

//shadow types2
char* __WSRshadowType2[]={
"m:WSSTR In",
"n:WSSTR Out",
"o:WSSTR Etched in",
"p:WSSTR Etched out",
"q:WSSTR Border",
NULL
};

//shadow type values2
char* __WSRshadowType2D[]={
"1",
"0",
"3",
"2",
"4",
NULL
};

//pixmap types
char* __WSRpixmapStyle[]={
"s:WSSTR Window",
"t:WSSTR Dynamic pixmap",
NULL
};

//pixmap type values
char* __WSRpixmapStyleD[]={
"0",
"1",
NULL
};

//indicator types
char* __WSRindicatorType[]={
"u:WSSTR In/Out",
"v:WSSTR Out",
"w:WSSTR In",
"x:WSSTR None",
NULL
};

//indicator type values
char* __WSRindicatorTypeD[]={
"0",
"1",
"2",
"3",
NULL
};

//WSCbool types0
char* __WSRbool[]={
"y:WSSTR False",
"z:WSSTR True",
NULL
};

//WSCbool type values0
char* __WSRboolD[]={
"0",
"1",
NULL
};

//WSCbool types1
char* __WSRbool1[]={
"A:WSSTR Not allow",
"B:WSSTR Allow",
NULL
};

//WSCbool type values1
char* __WSRbool1D[]={
"0",
"1",
NULL
};

//WSCbool types2
char* __WSRbool2[]={
"C:WSSTR Invisible",
"D:WSSTR Visible",
NULL
};

//WSCbool type values2 
char* __WSRbool2D[]={
"0",
"1",
NULL
};

//WSCbool types3
char* __WSRbool3[]={
"E:WSSTR Off",
"F:WSSTR On",
NULL
};

//WSCbool type values3
char* __WSRbool3D[]={
"0",
"1",
NULL
};

//WSCbool types4
char* __WSRbool4[]={
"G:WSSTR no",
"H:WSSTR yes",
NULL
};

//WSCbool type values4
char* __WSRbool4D[]={
"0",
"1",
NULL
};

char* __WSRbool5[] = {
"I:WSSTR Invisible",
"J:WSSTR Visible",
NULL
};

char* __WSRbool5D[] = {
"0",
"1",
NULL
};

char* __WSRbool6[] = {
"K:WSSTR No effective",
"L:WSSTR Effective",
NULL
};

char* __WSRbool6D[] = {
"0",
"1",
NULL
};


//string alignments (vertical)
char* __WSRalignmentV[]={
"M:WSSTR Top",
"N:WSSTR Center",
"O:WSSTR Bottom",
NULL
};

//string alignment (vertical) values
char* __WSRalignmentVD[]={
"3",
"2",
"4",
NULL
};

//string alignments (vertical)
char* __WSRalignmentV2[]={
"M:WSSTR None",
"M:WSSTR Top",
"N:WSSTR Center",
"O:WSSTR Bottom",
"R:WSSTR Adjust",
NULL
};

//string alignment (vertical) values
char* __WSRalignmentV2D[]={
"0",
"1",
"2",
"3",
"4",
NULL
};


//string alignments (horizontal)
char* __WSRalignmentH[]={
"P:WSSTR Left",
"Q:WSSTR Center",
"R:WSSTR Right",
NULL
};

//string alignment (horizontal) values
char* __WSRalignmentHD[]={
"0",
"2",
"1",
NULL
};

//string alignments (horizontal)
char* __WSRalignmentH2[]={
"M:WSSTR None",
"P:WSSTR Left",
"Q:WSSTR Center",
"R:WSSTR Right",
"R:WSSTR Adjust",
NULL
};

//string alignment (horizontal) values
char* __WSRalignmentH2D[]={
"0",
"1",
"2",
"3",
"4",
NULL
};


//orientation types
char* __WSRorientation[]={
"S:WSSTR Horizontal",
"T:WSSTR Vertical",
NULL
};

//orientation types
char* __WSRorientation2[]={
"T:WSSTR Landscape",
"S:WSSTR Portrait",
NULL
};


//orientation type values
char* __WSRorientationD[]={
"0",
"1",
NULL
};

//orientation type values
char* __WSRorientation2D[]={
"0",
"1",
NULL
};



//line types
char* __WSRlineType[]={
"U:WSSTR Line",
"V:WSSTR Dashed line",
"W:WSSTR Double dashed line",
"X:WSSTR Double dashed line2",
"Y:WSSTR Double dashed line3",
"Z:WSSTR Double dashed line4",
"a:WSSTR Double dashed line5",
"b:WSSTR Double dashed line6",
"c:WSSTR Short dashed line",
NULL
};

//line type values
char* __WSRlineTypeD[]={
"0",
"1",
"2",
"3",
"4",
"5",
"6",
"7",
"8",
NULL
};

//hatch patterns
char* __WSRhatchPattern[]={
"d:WSSTR Plane",
"e:WSSTR Oblique lines1",
"f:WSSTR Oblique lines2",
"g:WSSTR Vert. lines",
"h:WSSTR Horiz. lines",
"i:WSSTR Oblique cross",
"j:WSSTR Lattice",
"k:WSSTR Dot",
NULL
};

//hatch pattern values
char* __WSRhatchPatternD[]={
"0",
"1",
"2",
"3",
"4",
"5",
"6",
"7",
NULL
};

//arc types
char* __WSRarcType[]={
"l:WSSTR Arc open",
"m:WSSTR Arc close",
"n:WSSTR Pie",
NULL
};

//arc type values
char* __WSRarcTypeD[]={
"0",
"1",
"2",
NULL
};

//rates
char* __WSRrateType[]={
"o:WSSTR 0.25s",
"p:WSSTR 0.50s",
"q:WSSTR 0.75s",
"r:WSSTR 1.00s",
"s:WSSTR 2.00s",
"t:WSSTR 3.00s",
"u:WSSTR 5.00s",
NULL
};

//rate values
char* __WSRrateTypeD[]={
"1",
"2",
"3",
"4",
"8",
"12",
"20",
NULL
};

//date formats
char* __WSRdateFormat[]={
"v:WSSTR  (None) ",
"w:WSSTR mm/dd/yyyy",
"x:WSSTR yyyy/mm/dd",
"y:WSSTR mm/dd/yy",
"z:WSSTR yy/mm/dd",
"A:WSSTR dd/mm/yyyy ",
"B:WSSTR dd/mm/yy ",
NULL
};

//date format values
char* __WSRdateFormatD[]={
"0",
"1",
"2",
"3",
"4",
"5",
"6",
NULL
};

//weed formats
char* __WSRweekFormat[]={
"C:WSSTR (None)",
"D:WSSTR SUN    ",
"E:WSSTR (SUN)  ",
NULL
};

//weed format values
char* __WSRweekFormatD[]={
"0",
"1",
"2",
NULL
};

//clock formats
char* __WSRclockFormat[]={
"F:WSSTR  (none)",
"G:WSSTR   12:00",
"H:WSSTR   24:00",
"I:WSSTR AM 12:00:00",
"J:WSSTR 11:00:00",
"K:WSSTR 23:00:00",
"L:WSSTR AM:00:00",
NULL
};

//clock format values
char* __WSRclockFormatD[]={
"0",
"1",
"2",
"3",
"4",
"5",
"6",
NULL
};

//title types
char* __WSRtitleBar[]={
"M:WSSTR No title",
"N:WSSTR Full",
"O:WSSTR Title",
"P:WSSTR Minimize btn",
"Q:WSSTR Maximize btn",
"R:WSSTR Border",
"S:WSSTR Override redirect",
NULL
};

//title type values
char* __WSRtitleBarD[]={
"0",
"1",
"2",
"3",
"4",
"5",
"6",
NULL
};

//title types2
char* __WSRtitleBar2[]={
"M:WSSTR No title",
"N:WSSTR Full",
"O:WSSTR Title",
"P:WSSTR Minimize btn",
"Q:WSSTR Maximize btn",
"R:WSSTR Border",
NULL
};

//title type values2
char* __WSRtitleBar2D[]={
"0",
"1",
"2",
"3",
"4",
"5",
NULL
};


//arrow direction types
char* __WSRarrowDirection[] = {
"T:WSSTR Up",
"U:WSSTR Down",
"V:WSSTR Left",
"W:WSSTR Right",
NULL
};

//arrow direction type values
char* __WSRarrowDirectionD[] = {
"3",
"4",
"0",
"1",
NULL
};

//gradation
char* __WSRgradation[]={
"X:WSSTR None",
"Y:WSSTR LT to RB",
"Z:WSSTR RT to LB",
"a:WSSTR LB to RT",
"b:WSSTR RB to LT",
"c:WSSTR T to B",
"d:WSSTR B to T",
"e:WSSTR L to R",
"f:WSSTR R to L",
NULL
};

//gradationD
char* __WSRgradationD[]={
"0",
"1",
"2",
"3",
"4",
"5",
"6",
"7",
"8",
NULL
};

//dataSource
char* __WSRdataSource[]={
"X:WSSTR None",
"X:WSSTR Instance",
"X:WSSTR File",
NULL
};

//dataSourceD
char* __WSRdataSourceD[]={
"0",
"1",
"2",
NULL
};

//prformat
char* __WSRprformat[]={
"X:WSSTR A4",
"X:WSSTR A5",
"X:WSSTR A3",
"X:WSSTR B4",
"X:WSSTR B5",
"X:WSSTR Letter",
"X:WSSTR Legal",
"X:WSSTR Statement",
"X:WSSTR Tabloid",
"X:WSSTR Ledger",
"X:WSSTR Folio",
"X:WSSTR Quarto",
"X:WSSTR 10x14",
"X:WSSTR Executive",
"X:WSSTR Free",
NULL
};

//prformatD
char* __WSRprformatD[]={
"0",
"1",
"2",
"3",
"4",
"5",
"6",
"7",
"8",
"9",
"10",
"11",
"12",
"13",
"14",
NULL
};

//pr_out
char* __WSRprOut[]={
"X:WSSTR PostScript",
"X:WSSTR EPS",
#ifdef MSW
"X:WSSTR Printer",
#endif
NULL
};

//prOutD
char* __WSRprOutD[]={
"0",
"1",
#ifdef MSW
"2",
#endif
NULL
};

//db type
char* __WSRtypedb[]={
"X:WSSTR ODBC",
"X:WSSTR PostgreSQL",
"X:WSSTR MySQL",
NULL
};

//db type
char* __WSRtypedbD[]={
"0",
"1",
"2",
NULL
};

char** _WSRtype(){ return __WSRtype;};
char** _WSRtypeD(){ return __WSRtypeD;};
char** _WSRblinkType(){ return __WSRblinkType;};
char** _WSRblinkTypeD(){ return __WSRblinkTypeD;};
char** _WSRshadowType(){ return __WSRshadowType;};
char** _WSRshadowTypeD(){ return __WSRshadowTypeD;};
char** _WSRshadowType2(){ return __WSRshadowType2;};
char** _WSRshadowType2D(){ return __WSRshadowType2D;};
char** _WSRpixmapStyle(){ return __WSRpixmapStyle;};
char** _WSRpixmapStyleD(){ return __WSRpixmapStyleD;};
char** _WSRindicatorType(){ return __WSRindicatorType;};
char** _WSRindicatorTypeD(){ return __WSRindicatorTypeD;};
char** _WSRbool(){ return __WSRbool;};
char** _WSRboolD(){ return __WSRboolD;};
char** _WSRbool1(){ return __WSRbool1;};
char** _WSRbool1D(){ return __WSRbool1D;};
char** _WSRbool2(){ return __WSRbool2;};
char** _WSRbool2D(){ return __WSRbool2D;};
char** _WSRbool3(){ return __WSRbool3;};
char** _WSRbool3D(){ return __WSRbool3D;};
char** _WSRbool4(){ return __WSRbool4;};
char** _WSRbool4D(){ return __WSRbool4D;};
char** _WSRbool5(){ return __WSRbool5;};
char** _WSRbool5D(){ return __WSRbool5D;};
char** _WSRbool6(){ return __WSRbool6;};
char** _WSRbool6D(){ return __WSRbool6D;};
char** _WSRalignmentV(){ return __WSRalignmentV;};
char** _WSRalignmentVD(){ return __WSRalignmentVD;};
char** _WSRalignmentH(){ return __WSRalignmentH;};
char** _WSRalignmentHD(){ return __WSRalignmentHD;};
char** _WSRalignmentV2(){ return __WSRalignmentV2;};
char** _WSRalignmentV2D(){ return __WSRalignmentV2D;};
char** _WSRalignmentH2(){ return __WSRalignmentH2;};
char** _WSRalignmentH2D(){ return __WSRalignmentH2D;};
char** _WSRorientation(){ return __WSRorientation;};
char** _WSRorientationD(){ return __WSRorientationD;};
char** _WSRlineType(){ return __WSRlineType;};
char** _WSRlineTypeD(){ return __WSRlineTypeD;};
char** _WSRhatchPattern(){ return __WSRhatchPattern;};
char** _WSRhatchPatternD(){ return __WSRhatchPatternD;};
char** _WSRarcType(){ return __WSRarcType;};
char** _WSRarcTypeD(){ return __WSRarcTypeD;};
char** _WSRrateType(){ return __WSRrateType;};
char** _WSRrateTypeD(){ return __WSRrateTypeD;};
char** _WSRdateFormat(){ return __WSRdateFormat;};
char** _WSRdateFormatD(){ return __WSRdateFormatD;};
char** _WSRweekFormat(){ return __WSRweekFormat;};
char** _WSRweekFormatD(){ return __WSRweekFormatD;};
char** _WSRclockFormat(){ return __WSRclockFormat;};
char** _WSRclockFormatD(){ return __WSRclockFormatD;};
char** _WSRtitleBar(){ return __WSRtitleBar;};
char** _WSRtitleBarD(){ return __WSRtitleBarD;};
char** _WSRtitleBar2(){ return __WSRtitleBar2;};
char** _WSRtitleBar2D(){ return __WSRtitleBar2D;};
char** _WSRarrowDirection(){ return __WSRarrowDirection;};
char** _WSRarrowDirectionD(){ return __WSRarrowDirectionD;};
char** _WSRgradation(){ return __WSRgradation;};
char** _WSRgradationD(){ return __WSRgradationD;};
char** _WSRdataSource(){ return __WSRdataSource;};
char** _WSRdataSourceD(){ return __WSRdataSourceD;};
char** _WSRprformat(){ return __WSRprformat;};
char** _WSRprformatD(){ return __WSRprformatD;};
char** _WSRprOut(){ return __WSRprOut;};
char** _WSRprOutD(){ return __WSRprOutD;};
char** _WSRorientation2(){ return __WSRorientation2;};
char** _WSRorientation2D(){ return __WSRorientation2D;};
char** _WSRtypedb(){ return __WSRtypedb;};
char** _WSRtypedbD(){ return __WSRtypedbD;};


